# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.checkout_session_line_item_external import CheckoutSessionLineItemExternal
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class ProductBundleExternal(BaseModel):
    """
    ProductBundleExternal
    """ # noqa: E501
    account_id: StrictStr = Field(description="Unique identifier of the account.")
    amount_subtotal_atom: StrictInt = Field(description="The integer amount representing the subtotal amount for the bundle line items.")
    amount_total_atom: StrictInt = Field(description="The integer amount representing the total amount for the bundle line items, after discounts and taxes.")
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    id: StrictStr = Field(description="Unique Identifier of the bundle.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    line_items: Optional[List[CheckoutSessionLineItemExternal]] = Field(default=None, description="The line items included in this bundle.")
    name: StrictStr = Field(description="Name of the bundle.")
    object: Optional[ObjectName] = None
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["account_id", "amount_subtotal_atom", "amount_total_atom", "created_at", "id", "is_deleted", "line_items", "name", "object", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductBundleExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in line_items (list)
        _items = []
        if self.line_items:
            for _item_line_items in self.line_items:
                if _item_line_items:
                    _items.append(_item_line_items.to_dict())
            _dict['line_items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductBundleExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "amount_subtotal_atom": obj.get("amount_subtotal_atom"),
            "amount_total_atom": obj.get("amount_total_atom"),
            "created_at": obj.get("created_at"),
            "id": obj.get("id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "line_items": [CheckoutSessionLineItemExternal.from_dict(_item) for _item in obj["line_items"]] if obj.get("line_items") is not None else None,
            "name": obj.get("name"),
            "object": obj.get("object"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


